<template lang="pug">
loader(:loading="!loaded", title="Loading accounts...")
  .text-h4.q-pt-md Create a Shared Document

  loader(:loading="submitting", title="Submitting your document...")
    q-expansion-item.q-my-md.bg-grey-2(
      v-model="expanded",
      q-expand-separator,
      :label="loaded && selectedGoogleAccountId && googleAccounts[selectedGoogleAccountId] ? `Using account: ${googleAccounts[selectedGoogleAccountId].name} (${googleAccounts[selectedGoogleAccountId].email})` : 'No Account Selected'",
      caption="The created document (and its copies) will be saved to this account's Google Drive storage."
    )
      q-card.bg-grey-2(flat)
        q-card-section(horizontal)
          q-card-section.col(v-if="googleAccounts && accounts.length > 1")
            q-select(
              v-model="selectedGoogleAccountId",
              :options="accounts",
              label="Selected Account",
              :option-value="opt => (Object(opt) === opt && 'id' in opt ? opt.id : null)",
              emit-value,
              map-options,
              :option-label="opt => (Object(opt) === opt && 'name' in opt ? opt.name + ' ' + opt.email : '- None Selected -')"
            )
          q-card-section.col
            q-btn(
              style="margin-top: 1em",
              :loading="doingGoogleLogin",
              type="a",
              v-on:click="startGoogleLogin",
              flat,
              color="primary"
            ) Link New Account

    div(v-if="googleAccounts && Object.keys(googleAccounts).length > 0")
      div
        .text-h5.q-pt-md Document Template

        q-input.q-my-md(
          v-model="newTitle",
          label="Document Title",
          outlined,
          :rules="[val => !!val || 'Field is required']"
        )

        div
          i Sections (e.g. workshop activities) in your document for participants to work through.

          google-doc-section(
            v-for="(n, index) in sections",
            :id="n.ref",
            :sectionNumber="index + 1",
            :canDelete="index > 0",
            :title="sections[index].data.title",
            :content="sections[index].data.content",
            :response="sections[index].data.response",
            ref="sections[index].ref",
            :key="sections[index].ref"
          )

      q-btn(type="a", v-on:click="addDocSection", flat, color="primary") Add Section

      q-btn(type="a", v-on:click="addNewDocument", color="positive") {{existingDoc ? "Update Document on" : "Save Document to"}} Google Drive

      q-btn(type="a", v-on:click="cancelEditDocs", flat, color="primary") Cancel

    #gdoc-signin-prompt(v-else)
      p ZoomSense needs access to a Google Account in order to create and distribute documents. Please sign in to continue:
      a.googleBtn(v-on:click="startGoogleLogin")
</template>

<script lang="ts">
import Vue, { PropType } from "vue";
import {
  getGDocsMeetingFirebasePath,
  GDocsPluginDataMeeting,
  GDocsGoogleDocument,
  GDocsPluginGoogleDocumentSection,
  GDocsPluginGoogleDocumentSectionData,
  GDocsPluginGoogleAccount,
  getGDocsUserLinkedAccountsFirebasePath
} from "zoomsense-plugin-gdocs-shared";
import * as firebase from "firebase";
import { ZoomSenseClientFirebaseDB } from "@zoomsense/zoomsense-firebase";

// These unassigned imports pull in the relevant typescript definitions of these Vue extensions.
import "vue-cookies";
import "quasar";
import "vuefire";

import GoogleDocSection from "./GoogleDocSection.vue";
import { EventBus } from "./event-bus";
import Loader from "./Loader.vue";

export default Vue.extend({
  name: "EditDoc",
  props: {
    meetingId: {
      required: true,
      type: String,
    },
    userId: {
      required: true,
      type: String,
    },
    documentId: {
      type: String,
    },
    firebase: {
      required: true,
      type: Object as PropType<ZoomSenseClientFirebaseDB>,
    },
    functions: {
      required: true,
      type: Object as PropType<firebase.functions.Functions>,
    },
  },

  data() {
    return {
      gDocsMeeting: {} as GDocsPluginDataMeeting,

      existingDoc: undefined as GDocsGoogleDocument | undefined,

      selectedGoogleAccountId: null as null | string,
      googleAccounts: {} as {[googleAccountId: string]: GDocsPluginGoogleAccount},
      submitting: false,

      newTitle: null as string | null,
      sections: [] as GDocsPluginGoogleDocumentSection[],
      loaded: false,
      expanded: true,
      doingGoogleLogin: false,
    };
  },
  async created() {
    await this.$typedRtdbBind("gDocsMeeting", this.firebase.ref(getGDocsMeetingFirebasePath(this.meetingId)));
    // load in existing data if we're editing an existing doc
    const existingDoc = this.documentId ? this.gDocsMeeting.documents?.[this.documentId] : undefined;
    if (existingDoc) {
      this.newTitle = existingDoc.title;
      this.selectedGoogleAccountId = existingDoc.googleAccountId;
      this.sections = [];
      existingDoc.sections?.forEach((section) => {
        this.sections.push({
          type: GoogleDocSection,
          ref: this.randomNumber(),
          data: section.data,
        });
      });
      this.existingDoc = existingDoc;
    } else {
      // start with one section
      this.addDocSection();
    }

    await this.$typedRtdbBind("googleAccounts", this.firebase.ref(getGDocsUserLinkedAccountsFirebasePath(this.userId)))
    this.loaded = true;
  },
  mounted: function () {
    EventBus.$on("delete-gdoc-section", (sectionId: number) => {
      const sectionIndex = this.sections.findIndex((section) => (section.ref === sectionId));
      if (sectionIndex >= 0) {
        this.sections.splice(sectionIndex, 1);
      }
    });

    EventBus.$on("gdoc-section-dataChanged", (data: GDocsPluginGoogleDocumentSectionData) => {
      const sectionIndex = this.sections.findIndex((section) => (section.ref === data.id));
      if (sectionIndex >= 0) {
        this.sections[sectionIndex].data = data;
      }
    });
  },
  computed: {
    accounts(): {email: string; name: string; picture: string; id: string}[] {
      // only need basic profile info - i.e. not tokens
      const googleAccounts = this.googleAccounts;
      const googleAccountIds = Object.keys(googleAccounts);
      if (googleAccountIds.length === 0) {
        this.selectedGoogleAccountId = null;
        this.expanded = true;
      } else if (!this.selectedGoogleAccountId) {
        this.selectedGoogleAccountId = googleAccountIds[0];
        this.expanded = false;
      }
      return googleAccountIds
        .map((accountId) => ({
          email: googleAccounts[accountId]["email"],
          name: googleAccounts[accountId]["name"],
          picture: googleAccounts[accountId]["picture"],
          id: accountId,
        }));
    },
  },
  methods: {
    async startGoogleLogin() {
      this.doingGoogleLogin = true;

      const existingUrl = new URL(window.location.href);
      existingUrl.searchParams.set("auth", "success");
      const returnUrl = encodeURIComponent(existingUrl.toString());
      const authWindow = window.open();

      try {
        // We have to call window.open before async operations, because we lose the trusted status of the click event
        // callback when the synchronous code exits. See https://www.w3.org/TR/DOM-Level-3-Events/#trusted-events
        const googleAuth = this.functions.httpsCallable("GDocs-googleAuth");
        const authUrl = await googleAuth({ returnUrl });
        if (authWindow) {
          authWindow.location.href = authUrl.data;
        } else {
          this.$q.notify({
            type: "negative",
            message: "User cancelled or closed the OAuth window.",
          });
        }
      } catch (error) {
        authWindow?.close();
        console.error("Google sign-in error", error);
        this.$q.notify({
          type: "negative",
          message: "There was an error trying to sign in - please try again later.",
        });
      }
      this.doingGoogleLogin = false;
    },
    addNewDocument: async function () {
      if (!this.newTitle?.trim()) {
        this.$q.notify({
          type: "negative",
          message: "Please enter a title for your document",
        });
        return;
      }

      for (const [index, section] of this.sections.entries()) {
        if (!section.data.title?.trim()) {
          this.$q.notify({
            type: "negative",
            message: `Please enter a title for section ${index + 1}.`,
          });
          return;
        }
      }

      const cached = this.sections;
      this.submitting = true;

      try {
        const addOrUpdate = this.functions.httpsCallable("GDocs-googleDocsAddOrUpdateDocument");
        await addOrUpdate({
          meetingId: this.meetingId,
          documentId: this.documentId,
          doc: {
            googleAccountId: this.selectedGoogleAccountId,
            title: this.newTitle,
            sections: this.sections.map(({ data }) => ({ data })),
          },
        });
        this.$emit("finish-edit-doc");
      } catch (error) {
        console.error(error);
        this.$q.notify({
          type: "negative",
          message: "There was an error saving your document. Please try later.",
        });
        this.submitting = false;
        this.sections = cached;
      }
    },
    addDocSection() {
      this.sections.push({
        type: GoogleDocSection,
        ref: this.randomNumber(),
        data: { response: true, id: this.randomNumber(), title: "", content: "" },
      });
    },
    randomNumber() {
      return Math.floor(Math.random() * 100000);
    },
    cancelEditDocs() {
      this.$emit("finish-edit-doc");
    },
  },
  components: {
    GoogleDocSection,
    Loader
  },
});
</script>

<style scoped>
#gdoc-signin-prompt {
  margin-top: 50px;
}
</style>